Index: netwerk/cookie/src/nsCookieContainer.cpp
===================================================================
RCS file: netwerk/cookie/src/nsCookieContainer.cpp
diff -N netwerk/cookie/src/nsCookieContainer.cpp
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ netwerk/cookie/src/nsCookieContainer.cpp	14 May 2007 09:24:14 -0000
@@ -0,0 +1,1268 @@
+// vim:ts=2:sw=2:et:
+/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
+/* ***** BEGIN LICENSE BLOCK *****
+ * Version: MPL 1.1/GPL 2.0/LGPL 2.1
+ *
+ * The contents of this file are subject to the Mozilla Public License Version
+ * 1.1 (the "License"); you may not use this file except in compliance with
+ * the License. You may obtain a copy of the License at
+ * http://www.mozilla.org/MPL/
+ *
+ * Software distributed under the License is distributed on an "AS IS" basis,
+ * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
+ * for the specific language governing rights and limitations under the
+ * License.
+ *
+ * The Original Code is mozilla.org code.
+ *
+ * The Initial Developer of the Original Code is
+ * Netscape Communications Corporation.
+ * Portions created by the Initial Developer are Copyright (C) 2007
+ * the Initial Developer. All Rights Reserved.
+ *
+ * Contributor(s):
+ *   Daniel Witte <dwitte@stanford.edu>
+ *   Michiel van Leeuwen <mvl@exedo.nl>
+ *   Loune Lam <lpgcritter at nasquan dot com>
+ *
+ * Alternatively, the contents of this file may be used under the terms of
+ * either the GNU General Public License Version 2 or later (the "GPL"), or
+ * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
+ * in which case the provisions of the GPL or the LGPL are applicable instead
+ * of those above. If you wish to allow use of your version of this file only
+ * under the terms of either the GPL or the LGPL, and not to allow others to
+ * use your version of this file under the terms of the MPL, indicate your
+ * decision by deleting the provisions above and replace them with the notice
+ * and other provisions required by the GPL or the LGPL. If you do not delete
+ * the provisions above, a recipient may use your version of this file under
+ * the terms of any one of the MPL, the GPL or the LGPL.
+ *
+ * ***** END LICENSE BLOCK ***** */
+
+#include "nsCookieContainer.h"
+#include "nsIServiceManager.h"
+
+#include "nsIIOService.h"
+#include "nsIPrefBranch.h"
+#include "nsIPrefBranch2.h"
+#include "nsIPrefService.h"
+#include "nsICookieConsent.h"
+#include "nsICookiePermission.h"
+#include "nsIURI.h"
+#include "nsIURL.h"
+#include "nsIChannel.h"
+#include "nsIHttpChannel.h"
+#include "nsIHttpChannelInternal.h" // evil hack!
+#include "nsIPrompt.h"
+#include "nsITimer.h"
+#include "nsIFile.h"
+#include "nsIObserverService.h"
+#include "nsILineInputStream.h"
+
+#include "nsCOMArray.h"
+#include "nsArrayEnumerator.h"
+#include "nsAutoPtr.h"
+#include "nsReadableUtils.h"
+#include "nsCRT.h"
+#include "prtime.h"
+#include "prprf.h"
+#include "prnetdb.h"
+#include "nsNetUtil.h"
+#include "nsNetCID.h"
+#include "nsAppDirectoryServiceDefs.h"
+#include "nsIArray.h"
+#include "nsIMutableArray.h"
+#include "nsArrayUtils.h"
+
+/******************************************************************************
+ * nsCookieService impl:
+ * useful types & constants
+ ******************************************************************************/
+
+// XXX_hack. See bug 178993.
+// This is a hack to hide HttpOnly cookies from older browsers
+//
+static const char kHttpOnlyPrefix[] = "#HttpOnly_";
+
+static const char kCookieFileNamePrefix[] = "cookies";
+static const char kCookieFileNameExt[] = ".txt";
+
+static const PRUint32 kLazyWriteTimeout = 5000; //msec
+
+#undef  LIMIT
+#define LIMIT(x, low, high, default) ((x) >= (low) && (x) <= (high) ? (x) : (default))
+
+// default limits for the cookie list. these can be tuned by the
+// network.cookie.maxNumber and network.cookie.maxPerHost prefs respectively.
+static const PRUint32 kMaxNumberOfCookies = 1000;
+static const PRUint32 kMaxCookiesPerHost  = 50;
+
+// XXX these casts and constructs are horrible, but our nsInt64/nsTime
+// classes are lacking so we need them for now. see bug 198694.
+#define USEC_PER_SEC   (nsInt64(1000000))
+#define NOW_IN_SECONDS (nsInt64(PR_Now()) / USEC_PER_SEC)
+
+// pref string constants
+static const char kPrefCookiesPermissions[] = "network.cookie.cookieBehavior";
+static const char kPrefMaxNumberOfCookies[] = "network.cookie.maxNumber";
+static const char kPrefMaxCookiesPerHost[]  = "network.cookie.maxPerHost";
+static const char kInitialCookieContainerId[] = "@mozilla.org/cookie-container;1#MAIN";
+
+
+// stores linked list iteration state, and provides a rudimentary
+// list traversal method
+struct nsListIter
+{
+  nsListIter() {}
+
+  nsListIter(nsCookieEntry *aEntry)
+   : entry(aEntry)
+   , prev(nsnull)
+   , current(aEntry ? aEntry->Head() : nsnull) {}
+
+  nsListIter(nsCookieEntry *aEntry,
+             nsCookie      *aPrev,
+             nsCookie      *aCurrent)
+   : entry(aEntry)
+   , prev(aPrev)
+   , current(aCurrent) {}
+
+  nsListIter& operator++() { prev = current; current = current->Next(); return *this; }
+
+  nsCookieEntry *entry;
+  nsCookie      *prev;
+  nsCookie      *current;
+};
+
+// stores temporary data for enumerating over the hash entries,
+// since enumeration is done using callback functions
+struct nsEnumerationData
+{
+  nsEnumerationData(nsInt64 aCurrentTime,
+                    PRInt64 aOldestTime)
+   : currentTime(aCurrentTime)
+   , oldestTime(aOldestTime)
+   , iter(nsnull, nsnull, nsnull) {}
+
+  // the current time
+  nsInt64 currentTime;
+
+  // oldest lastAccessed time in the cookie list. use aOldestTime = LL_MAXINT
+  // to enable this search, LL_MININT to disable it.
+  nsInt64 oldestTime;
+
+  // an iterator object that points to the desired cookie
+  nsListIter iter;
+};
+
+/******************************************************************************
+ * Cookie logging handlers
+ * used for logging in nsCookieService
+ ******************************************************************************/
+
+// logging handlers
+#ifdef MOZ_LOGGING
+// in order to do logging, the following environment variables need to be set:
+//
+//    set NSPR_LOG_MODULES=cookie:3 -- shows rejected cookies
+//    set NSPR_LOG_MODULES=cookie:4 -- shows accepted and rejected cookies
+//    set NSPR_LOG_FILE=cookie.log
+//
+// this next define has to appear before the include of prlog.h
+#define FORCE_PR_LOG // Allow logging in the release build
+#include "prlog.h"
+#endif
+
+// define logging macros for convenience
+#define SET_COOKIE PR_TRUE
+#define GET_COOKIE PR_FALSE
+
+#ifdef PR_LOGGING
+static PRLogModuleInfo *sCookieLog = PR_NewLogModule("cookie");
+
+#define COOKIE_LOGFAILURE(a, b, c, d) LogFailure(a, b, c, d)
+#define COOKIE_LOGSUCCESS(a, b, c, d) LogSuccess(a, b, c, d)
+
+static void
+LogFailure(PRBool aSetCookie, nsIURI *aHostURI, const char *aCookieString, const char *aReason)
+{
+  // if logging isn't enabled, return now to save cycles
+  if (!PR_LOG_TEST(sCookieLog, PR_LOG_WARNING)) {
+    return;
+  }
+
+  nsCAutoString spec;
+  if (aHostURI)
+    aHostURI->GetAsciiSpec(spec);
+
+  PR_LOG(sCookieLog, PR_LOG_WARNING,
+    ("%s%s%s\n", "===== ", aSetCookie ? "COOKIE NOT ACCEPTED" : "COOKIE NOT SENT", " ====="));
+  PR_LOG(sCookieLog, PR_LOG_WARNING,("request URL: %s\n", spec.get()));
+  if (aSetCookie) {
+    PR_LOG(sCookieLog, PR_LOG_WARNING,("cookie string: %s\n", aCookieString));
+  }
+
+  PRExplodedTime explodedTime;
+  PR_ExplodeTime(PR_Now(), PR_GMTParameters, &explodedTime);
+  char timeString[40];
+  PR_FormatTimeUSEnglish(timeString, 40, "%c GMT", &explodedTime);
+
+  PR_LOG(sCookieLog, PR_LOG_WARNING,("current time: %s", timeString));
+  PR_LOG(sCookieLog, PR_LOG_WARNING,("rejected because %s\n", aReason));
+  PR_LOG(sCookieLog, PR_LOG_WARNING,("\n"));
+}
+
+static void
+LogSuccess(PRBool aSetCookie, nsIURI *aHostURI, const char *aCookieString, nsCookie *aCookie)
+{
+  // if logging isn't enabled, return now to save cycles
+  if (!PR_LOG_TEST(sCookieLog, PR_LOG_DEBUG)) {
+    return;
+  }
+
+  nsCAutoString spec;
+  aHostURI->GetAsciiSpec(spec);
+
+  PR_LOG(sCookieLog, PR_LOG_DEBUG,
+    ("%s%s%s\n", "===== ", aSetCookie ? "COOKIE ACCEPTED" : "COOKIE SENT", " ====="));
+  PR_LOG(sCookieLog, PR_LOG_DEBUG,("request URL: %s\n", spec.get()));
+  PR_LOG(sCookieLog, PR_LOG_DEBUG,("cookie string: %s\n", aCookieString));
+
+  PRExplodedTime explodedTime;
+  PR_ExplodeTime(PR_Now(), PR_GMTParameters, &explodedTime);
+  char timeString[40];
+  PR_FormatTimeUSEnglish(timeString, 40, "%c GMT", &explodedTime);
+
+  PR_LOG(sCookieLog, PR_LOG_DEBUG,("current time: %s", timeString));
+
+  if (aSetCookie) {
+    PR_LOG(sCookieLog, PR_LOG_DEBUG,("----------------\n"));
+    PR_LOG(sCookieLog, PR_LOG_DEBUG,("name: %s\n", aCookie->Name().get()));
+    PR_LOG(sCookieLog, PR_LOG_DEBUG,("value: %s\n", aCookie->Value().get()));
+    PR_LOG(sCookieLog, PR_LOG_DEBUG,("%s: %s\n", aCookie->IsDomain() ? "domain" : "host", aCookie->Host().get()));
+    PR_LOG(sCookieLog, PR_LOG_DEBUG,("path: %s\n", aCookie->Path().get()));
+
+    if (!aCookie->IsSession()) {
+      PR_ExplodeTime(aCookie->Expiry() * USEC_PER_SEC, PR_GMTParameters, &explodedTime);
+      PR_FormatTimeUSEnglish(timeString, 40, "%c GMT", &explodedTime);
+    }
+
+    PR_LOG(sCookieLog, PR_LOG_DEBUG,
+      ("expires: %s", aCookie->IsSession() ? "at end of session" : timeString));
+    PR_LOG(sCookieLog, PR_LOG_DEBUG,("is secure: %s\n", aCookie->IsSecure() ? "true" : "false"));
+  }
+  PR_LOG(sCookieLog, PR_LOG_DEBUG,("\n"));
+}
+
+// inline wrappers to make passing in nsAFlatCStrings easier
+static inline void
+LogFailure(PRBool aSetCookie, nsIURI *aHostURI, const nsAFlatCString &aCookieString, const char *aReason)
+{
+  LogFailure(aSetCookie, aHostURI, aCookieString.get(), aReason);
+}
+
+static inline void
+LogSuccess(PRBool aSetCookie, nsIURI *aHostURI, const nsAFlatCString &aCookieString, nsCookie *aCookie)
+{
+  LogSuccess(aSetCookie, aHostURI, aCookieString.get(), aCookie);
+}
+
+#else
+#define COOKIE_LOGFAILURE(a, b, c, d) /* nothing */
+#define COOKIE_LOGSUCCESS(a, b, c, d) /* nothing */
+#endif
+
+/******************************************************************************
+ * nsCookieService impl:
+ * private list sorting callbacks
+ *
+ * these functions return:
+ *   < 0 if the first element should come before the second element,
+ *     0 if the first element may come before or after the second element,
+ *   > 0 if the first element should come after the second element.
+ ******************************************************************************/
+
+// comparison function for sorting cookies before sending to a server.
+PR_STATIC_CALLBACK(int)
+compareCookiesForSending(const void *aElement1,
+                         const void *aElement2,
+                         void       *aData)
+{
+  const nsCookie *cookie1 = NS_STATIC_CAST(const nsCookie*, aElement1);
+  const nsCookie *cookie2 = NS_STATIC_CAST(const nsCookie*, aElement2);
+
+  // compare by cookie path length in accordance with RFC2109
+  int rv = cookie2->Path().Length() - cookie1->Path().Length();
+  if (rv == 0) {
+    // when path lengths match, older cookies should be listed first.  this is
+    // required for backwards compatibility since some websites erroneously
+    // depend on receiving cookies in the order in which they were sent to the
+    // browser!  see bug 236772.
+    rv = cookie1->CreationTime() - cookie2->CreationTime();
+  }
+  return rv;
+}
+
+// comparison function for sorting cookies by lastAccessed time, with most-
+// recently-used cookies listed first.
+PR_STATIC_CALLBACK(int)
+compareCookiesForWriting(const void *aElement1,
+                         const void *aElement2,
+                         void       *aData)
+{
+  const nsCookie *cookie1 = NS_STATIC_CAST(const nsCookie*, aElement1);
+  const nsCookie *cookie2 = NS_STATIC_CAST(const nsCookie*, aElement2);
+
+  // we may have overflow problems returning the result directly, so we need branches
+  nsInt64 difference = cookie2->LastAccessed() - cookie1->LastAccessed();
+  return (difference > nsInt64(0)) ? 1 : (difference < nsInt64(0)) ? -1 : 0;
+}
+
+/******************************************************************************
+ * nsCookieService impl:
+ * public methods
+ ******************************************************************************/
+
+NS_IMPL_ISUPPORTS5(nsCookieContainer,
+                   nsICookieContainer,
+                   nsICookieManager,
+                   nsICookieManager2,
+                   nsIObserver,
+                   nsISupportsWeakReference)
+
+nsCookieContainer::nsCookieContainer()
+ : mCookieCount(0)
+ , mCookieChanged(PR_FALSE)
+ , mMaxNumberOfCookies(kMaxNumberOfCookies)
+ , mMaxCookiesPerHost(kMaxCookiesPerHost)
+ , mSessionOnly(PR_FALSE)
+ , mCookieFile(nsnull)
+{
+}
+
+nsCookieContainer::~nsCookieContainer()
+{
+  if (mWriteTimer)
+    mWriteTimer->Cancel();
+}
+
+
+NS_IMETHODIMP
+nsCookieContainer::Init(const char *aContainerId)
+{
+  // check containerId
+  const char* z = aContainerId;
+  while (*z != 0 && *z != '#') z++;
+  if (*z == 0)
+    return NS_ERROR_INVALID_ARG;
+
+  if (*++z == '+') {
+    // has + prefix, which means session container, ie don't save
+    mSessionOnly = PR_TRUE;
+  }
+
+  mContainerId.Assign(aContainerId);
+
+  mObserverService = do_GetService("@mozilla.org/observer-service;1");
+
+  if (!mHostTable.Init()) {
+    return NS_ERROR_OUT_OF_MEMORY;
+  }
+
+  // trigger initialization code in profile-do-change
+  Observe(nsnull, "profile-do-change", nsnull);
+  return NS_OK;
+}
+
+NS_IMETHODIMP
+nsCookieContainer::Observe(nsISupports     *aSubject,
+                         const char      *aTopic,
+                         const PRUnichar *aData)
+{
+  // check the topic
+  if (!nsCRT::strcmp(aTopic, "profile-before-change")) {
+    // The profile is about to change,
+    // or is going away because the application is shutting down.
+    if (mWriteTimer) {
+      mWriteTimer->Cancel();
+      mWriteTimer = 0;
+    }
+
+    if (!nsCRT::strcmp(aData, NS_LITERAL_STRING("shutdown-cleanse").get())) {
+      RemoveAllFromMemory();
+      // delete the cookie file
+      if (mCookieFile) {
+        mCookieFile->Remove(PR_FALSE);
+      }
+    } else {
+      if (!mSessionOnly)
+        Write();
+      RemoveAllFromMemory();
+    }
+
+  } else if (!nsCRT::strcmp(aTopic, "profile-do-change")) {
+    // The profile has already changed.
+    // Now just read them from the new profile location.
+    // we also need to update the cached cookie file location
+    if (mSessionOnly)
+      return NS_OK;
+    nsresult rv = NS_GetSpecialDirectory(NS_APP_USER_PROFILE_50_DIR, getter_AddRefs(mCookieFile));
+    if (NS_SUCCEEDED(rv)) {
+      nsCAutoString cookieFileName(kCookieFileNamePrefix);
+      // we have a special name for the initial/main container (ie just cookies.txt)
+      if (!mContainerId.Equals(kInitialCookieContainerId)) {
+        cookieFileName.Append("_");
+        // get the portion of the container id after the # as part of the filename
+        char* z = (char *)mContainerId.get();
+        while (*z != 0 && *z != '#') z++;
+        z++;
+        cookieFileName.Append(z);
+      }
+      cookieFileName.Append(kCookieFileNameExt);
+      mCookieFile->AppendNative(cookieFileName);
+    }
+    Read();
+
+  } else if (!nsCRT::strcmp(aTopic, NS_PREFBRANCH_PREFCHANGE_TOPIC_ID)) {
+    nsCOMPtr<nsIPrefBranch> prefBranch = do_QueryInterface(aSubject);
+    if (prefBranch)
+      PrefChanged(prefBranch);
+  }
+
+  return NS_OK;
+}
+
+// helper function for GetCookieList
+static inline PRBool ispathdelimiter(char c) { return c == '/' || c == '?' || c == '#' || c == ';'; }
+
+NS_IMETHODIMP
+nsCookieContainer::GetCookieList(nsIURI           *aHostURI,
+                               const char       *aName,
+                               PRBool           aHttpBound,
+                               nsIArray         **aResult
+							   /*nsAutoVoidArray  &aResult*/)
+{
+  if (!aHostURI) {
+    COOKIE_LOGFAILURE(GET_COOKIE, nsnull, nsnull, "host URI is null");
+    return NS_OK;
+  }
+
+  nsAutoVoidArray result;
+
+  // get host and path from the nsIURI
+  // note: there was a "check if host has embedded whitespace" here.
+  // it was removed since this check was added into the nsIURI impl (bug 146094).
+  nsCAutoString hostFromURI, pathFromURI;
+  if (NS_FAILED(aHostURI->GetAsciiHost(hostFromURI)) ||
+      NS_FAILED(aHostURI->GetPath(pathFromURI))) {
+    COOKIE_LOGFAILURE(GET_COOKIE, aHostURI, nsnull, "couldn't get host/path from URI");
+    return NS_OK;
+  }
+  // trim trailing dots
+  hostFromURI.Trim(".");
+  // insert a leading dot, so we begin the hash lookup with the
+  // equivalent domain cookie host
+  hostFromURI.Insert(NS_LITERAL_CSTRING("."), 0);
+  ToLowerCase(hostFromURI);
+
+  // check if aHostURI is using an https secure protocol.
+  // if it isn't, then we can't send a secure cookie over the connection.
+  // if SchemeIs fails, assume an insecure connection, to be on the safe side
+  PRBool isSecure;
+  if (NS_FAILED(aHostURI->SchemeIs("https", &isSecure))) {
+    isSecure = PR_FALSE;
+  }
+
+  nsCookie *cookie;
+  nsInt64 currentTime = NOW_IN_SECONDS;
+  const char *currentDot = hostFromURI.get();
+  const char *nextDot = currentDot + 1;
+
+  // begin hash lookup, walking up the subdomain levels.
+  // we use nextDot to force a lookup of the original host (without leading dot).
+  do {
+    nsCookieEntry *entry = mHostTable.GetEntry(currentDot);
+    cookie = entry ? entry->Head() : nsnull;
+    for (; cookie; cookie = cookie->Next()) {
+      // check the cookie name, if appropriate
+      if (aName && *aName != 0 && !cookie->Name().Equals(aName)) {
+        continue;
+      }
+
+      // if the cookie is secure and the host scheme isn't, we can't send it
+      if (cookie->IsSecure() && !isSecure) {
+        continue;
+      }
+
+      // if the cookie is httpOnly and it's not going directly to the HTTP
+      // connection, don't send it
+      if (cookie->IsHttpOnly() && !aHttpBound) {
+        continue;
+      }
+
+      // calculate cookie path length, excluding trailing '/'
+      PRUint32 cookiePathLen = cookie->Path().Length();
+      if (cookiePathLen > 0 && cookie->Path().Last() == '/') {
+        --cookiePathLen;
+      }
+
+      // if the nsIURI path is shorter than the cookie path, don't send it back
+      if (!StringBeginsWith(pathFromURI, Substring(cookie->Path(), 0, cookiePathLen))) {
+        continue;
+      }
+
+      if (pathFromURI.Length() > cookiePathLen &&
+          !ispathdelimiter(pathFromURI.CharAt(cookiePathLen))) {
+        /*
+         * |ispathdelimiter| tests four cases: '/', '?', '#', and ';'.
+         * '/' is the "standard" case; the '?' test allows a site at host/abc?def
+         * to receive a cookie that has a path attribute of abc.  this seems
+         * strange but at least one major site (citibank, bug 156725) depends
+         * on it.  The test for # and ; are put in to proactively avoid problems
+         * with other sites - these are the only other chars allowed in the path.
+         */
+        continue;
+      }
+
+      // check if the cookie has expired
+      if (cookie->Expiry() <= currentTime) {
+        continue;
+      }
+
+      // all checks passed - add to list and update lastAccessed stamp of cookie
+      result.AppendElement(cookie);
+      cookie->SetLastAccessed(currentTime);
+    }
+
+    currentDot = nextDot;
+    if (currentDot)
+      nextDot = strchr(currentDot + 1, '.');
+
+  } while (currentDot);
+
+  // return cookies in order of path length; longest to shortest.
+  // this is required per RFC2109.  if cookies match in length,
+  // then sort by creation time (see bug 236772).
+  result.Sort(compareCookiesForSending, nsnull);
+
+  // because nsIArray doesn't have sort() we used nsAutoVoidArray above
+  // now we need to copy it into our nsIArray
+  nsCOMPtr<nsIMutableArray> iarray = do_CreateInstance(NS_ARRAY_CONTRACTID);
+  for (int i = 0; i < result.Count(); i++)
+    iarray->AppendElement(NS_STATIC_CAST(nsICookie*, result[i]), PR_FALSE);
+
+  *aResult = iarray;
+  NS_IF_ADDREF(*aResult);
+
+  return NS_OK;
+}
+
+NS_IMETHODIMP
+nsCookieContainer::SetCookie(nsIURI *aHostURI,
+						   nsICookie *cookie)
+{
+    AddInternal(NS_STATIC_CAST(nsCookie*, cookie), NOW_IN_SECONDS, aHostURI, nsnull);
+    
+    // write out the cookie file
+    if (!mSessionOnly)
+      LazyWrite();
+    
+    return NS_OK;
+}
+
+/* readonly attribute string containerId; */
+NS_IMETHODIMP
+nsCookieContainer::GetContainerId(char * *aContainerId)
+{
+    *aContainerId = (char *)nsMemory::Alloc((mContainerId.Length()+1) * sizeof(char));
+    memcpy(*aContainerId, mContainerId.get(), (mContainerId.Length()+1) * sizeof(char));
+    return NS_OK;
+}
+
+void
+nsCookieContainer::LazyWrite()
+{
+  if (mWriteTimer) {
+    mWriteTimer->SetDelay(kLazyWriteTimeout);
+  } else {
+    mWriteTimer = do_CreateInstance("@mozilla.org/timer;1");
+    if (mWriteTimer) {
+      mWriteTimer->InitWithFuncCallback(DoLazyWrite, this, kLazyWriteTimeout,
+                                        nsITimer::TYPE_ONE_SHOT);
+    }
+  }
+}
+
+void
+nsCookieContainer::DoLazyWrite(nsITimer *aTimer,
+                             void     *aClosure)
+{
+  nsCookieContainer *container = NS_REINTERPRET_CAST(nsCookieContainer*, aClosure);
+  container->Write();
+  container->mWriteTimer = 0;
+}
+
+// notify observers that the cookie list changed. there are four possible
+// values for aData:
+// "deleted" means a cookie was deleted. aCookie is the deleted cookie.
+// "added"   means a cookie was added. aCookie is the added cookie.
+// "changed" means a cookie was altered. aCookie is the new cookie.
+// "cleared" means the entire cookie list was cleared. aCookie is null.
+void
+nsCookieContainer::NotifyChanged(nsICookie2      *aCookie,
+                                 const PRUnichar *aData)
+{
+  mCookieChanged = PR_TRUE;
+
+  if (mObserverService)
+    mObserverService->NotifyObservers(aCookie, "cookie-changed", aData);
+
+}
+
+/******************************************************************************
+ * nsCookieService:
+ * pref observer impl
+ ******************************************************************************/
+
+void
+nsCookieContainer::PrefChanged(nsIPrefBranch *aPrefBranch)
+{
+  PRInt32 val;
+
+  mMaxNumberOfCookies = kMaxNumberOfCookies;
+  mMaxCookiesPerHost = kMaxCookiesPerHost;
+
+  if (NS_SUCCEEDED(aPrefBranch->GetIntPref(kPrefMaxNumberOfCookies, &val)))
+    mMaxNumberOfCookies = LIMIT(val, 0, 0xFFFF, 0xFFFF);
+
+  if (NS_SUCCEEDED(aPrefBranch->GetIntPref(kPrefMaxCookiesPerHost, &val)))
+    mMaxCookiesPerHost = LIMIT(val, 0, 0xFFFF, 0xFFFF);
+}
+
+/******************************************************************************
+ * nsICookieManager impl:
+ * nsICookieManager
+ ******************************************************************************/
+
+NS_IMETHODIMP
+nsCookieContainer::RemoveAll()
+{
+  RemoveAllFromMemory();
+  NotifyChanged(nsnull, NS_LITERAL_STRING("cleared").get());
+  if (!mSessionOnly)
+    Write();
+  return NS_OK;
+}
+
+PR_STATIC_CALLBACK(PLDHashOperator)
+COMArrayCallback(nsCookieEntry *aEntry,
+                 void          *aArg)
+{
+  for (nsCookie *cookie = aEntry->Head(); cookie; cookie = cookie->Next()) {
+    NS_STATIC_CAST(nsCOMArray<nsICookie>*, aArg)->AppendObject(cookie);
+  }
+  return PL_DHASH_NEXT;
+}
+
+NS_IMETHODIMP
+nsCookieContainer::GetEnumerator(nsISimpleEnumerator **aEnumerator)
+{
+  RemoveExpiredCookies(NOW_IN_SECONDS);
+
+  nsCOMArray<nsICookie> cookieList(mCookieCount);
+  mHostTable.EnumerateEntries(COMArrayCallback, &cookieList);
+
+  return NS_NewArrayEnumerator(aEnumerator, cookieList);
+}
+
+NS_IMETHODIMP
+nsCookieContainer::Add(const nsACString &aDomain,
+                       const nsACString &aPath,
+                       const nsACString &aName,
+                       const nsACString &aValue,
+                       PRBool            aIsSecure,
+                       PRBool            aIsSession,
+                       PRInt64           aExpiry)
+{
+  nsInt64 currentTime = NOW_IN_SECONDS;
+
+  nsRefPtr<nsCookie> cookie =
+    nsCookie::Create(aName, aValue, aDomain, aPath,
+                     nsInt64(aExpiry),
+                     currentTime,
+                     aIsSession,
+                     aIsSecure,
+                     PR_FALSE,
+                     nsICookie::STATUS_UNKNOWN,
+                     nsICookie::POLICY_UNKNOWN);
+  if (!cookie) {
+    return NS_ERROR_OUT_OF_MEMORY;
+  }
+
+  AddInternal(cookie, currentTime, nsnull, nsnull);
+  return NS_OK;
+}
+
+NS_IMETHODIMP
+nsCookieContainer::Remove(const nsACString &aHost,
+                          const nsACString &aName,
+                          const nsACString &aPath,
+                          PRBool           aBlocked)
+{
+  nsListIter matchIter;
+  if (FindCookie(PromiseFlatCString(aHost),
+                 PromiseFlatCString(aName),
+                 PromiseFlatCString(aPath),
+                 matchIter)) {
+    nsRefPtr<nsCookie> cookie = matchIter.current;
+    RemoveCookieFromList(matchIter);
+    NotifyChanged(cookie, NS_LITERAL_STRING("deleted").get());
+
+    // check if we need to add the host to the permissions blacklist.
+    if (aBlocked) {
+      nsCOMPtr<nsICookiePermission> permissionService = do_GetService(NS_COOKIEPERMISSION_CONTRACTID);
+      if (permissionService) {
+        nsCAutoString host(NS_LITERAL_CSTRING("http://") + cookie->RawHost());
+        nsCOMPtr<nsIURI> uri;
+        NS_NewURI(getter_AddRefs(uri), host);
+
+        if (uri)
+          permissionService->SetAccess(uri, nsICookiePermission::ACCESS_DENY);
+      }
+    }
+    if (!mSessionOnly)
+      LazyWrite();
+  }
+  return NS_OK;
+}
+
+/******************************************************************************
+ * nsCookieContainer impl:
+ * private file I/O functions
+ ******************************************************************************/
+
+nsresult
+nsCookieContainer::Read()
+{
+  nsresult rv;
+  nsCOMPtr<nsIInputStream> fileInputStream;
+  rv = NS_NewLocalFileInputStream(getter_AddRefs(fileInputStream), mCookieFile);
+  if (NS_FAILED(rv)) {
+    return rv;
+  }
+
+  nsCOMPtr<nsILineInputStream> lineInputStream = do_QueryInterface(fileInputStream, &rv);
+  if (NS_FAILED(rv)) {
+    return rv;
+  }
+
+  static const char kTrue[] = "TRUE";
+
+  nsCAutoString buffer;
+  PRBool isMore = PR_TRUE;
+  PRInt32 hostIndex, isDomainIndex, pathIndex, secureIndex, expiresIndex, nameIndex, cookieIndex;
+  nsASingleFragmentCString::char_iterator iter;
+  PRInt32 numInts;
+  PRInt64 expires;
+  PRBool isDomain, isHttpOnly = PR_FALSE;
+  nsInt64 currentTime = NOW_IN_SECONDS;
+  // we use lastAccessedCounter to keep cookies in recently-used order,
+  // so we start by initializing to currentTime (somewhat arbitrary)
+  nsInt64 lastAccessedCounter = currentTime;
+  nsCookie *newCookie;
+
+  /* file format is:
+   *
+   * host \t isDomain \t path \t secure \t expires \t name \t cookie
+   *
+   * if this format isn't respected we move onto the next line in the file.
+   * isDomain is "TRUE" or "FALSE" (default to "FALSE")
+   * isSecure is "TRUE" or "FALSE" (default to "TRUE")
+   * expires is a PRInt64 integer
+   * note 1: cookie can contain tabs.
+   * note 2: cookies are written in order of lastAccessed time:
+   *         most-recently used come first; least-recently-used come last.
+   */
+
+  /*
+   * ...but due to bug 178933, we hide HttpOnly cookies from older code
+   * in a comment, so they don't expose HttpOnly cookies to JS.
+   *
+   * The format for HttpOnly cookies is
+   *
+   * #HttpOnly_host \t isDomain \t path \t secure \t expires \t name \t cookie
+   *
+   */
+
+  while (isMore && NS_SUCCEEDED(lineInputStream->ReadLine(buffer, &isMore))) {
+    if (StringBeginsWith(buffer, NS_LITERAL_CSTRING(kHttpOnlyPrefix))) {
+      isHttpOnly = PR_TRUE;
+      hostIndex = sizeof(kHttpOnlyPrefix) - 1;
+    } else if (buffer.IsEmpty() || buffer.First() == '#') {
+      continue;
+    } else {
+      isHttpOnly = PR_FALSE;
+      hostIndex = 0;
+    }
+
+    // this is a cheap, cheesy way of parsing a tab-delimited line into
+    // string indexes, which can be lopped off into substrings. just for
+    // purposes of obfuscation, it also checks that each token was found.
+    // todo: use iterators?
+    if ((isDomainIndex = buffer.FindChar('\t', hostIndex)     + 1) == 0 ||
+        (pathIndex     = buffer.FindChar('\t', isDomainIndex) + 1) == 0 ||
+        (secureIndex   = buffer.FindChar('\t', pathIndex)     + 1) == 0 ||
+        (expiresIndex  = buffer.FindChar('\t', secureIndex)   + 1) == 0 ||
+        (nameIndex     = buffer.FindChar('\t', expiresIndex)  + 1) == 0 ||
+        (cookieIndex   = buffer.FindChar('\t', nameIndex)     + 1) == 0) {
+      continue;
+    }
+
+    // check the expirytime first - if it's expired, ignore
+    // nullstomp the trailing tab, to avoid copying the string
+    buffer.BeginWriting(iter);
+    *(iter += nameIndex - 1) = char(0);
+    numInts = PR_sscanf(buffer.get() + expiresIndex, "%lld", &expires);
+    if (numInts != 1 || nsInt64(expires) < currentTime) {
+      continue;
+    }
+
+    isDomain = Substring(buffer, isDomainIndex, pathIndex - isDomainIndex - 1)
+               .EqualsLiteral(kTrue);
+    const nsASingleFragmentCString &host = Substring(buffer, hostIndex, isDomainIndex - hostIndex - 1);
+    // check for bad legacy cookies (domain not starting with a dot, or containing a port),
+    // and discard
+    if (isDomain && !host.IsEmpty() && host.First() != '.' ||
+        host.FindChar(':') != kNotFound) {
+      continue;
+    }
+
+    // create a new nsCookie and assign the data.
+    newCookie =
+      nsCookie::Create(Substring(buffer, nameIndex, cookieIndex - nameIndex - 1),
+                       Substring(buffer, cookieIndex, buffer.Length() - cookieIndex),
+                       host,
+                       Substring(buffer, pathIndex, secureIndex - pathIndex - 1),
+                       nsInt64(expires),
+                       lastAccessedCounter,
+                       PR_FALSE,
+                       Substring(buffer, secureIndex, expiresIndex - secureIndex - 1).EqualsLiteral(kTrue),
+                       isHttpOnly,
+                       nsICookie::STATUS_UNKNOWN,
+                       nsICookie::POLICY_UNKNOWN);
+    if (!newCookie) {
+      return NS_ERROR_OUT_OF_MEMORY;
+    }
+
+    // trick: keep the cookies in most-recently-used order,
+    // by successively decrementing the lastAccessed time
+    lastAccessedCounter -= nsInt64(1);
+
+    if (!AddCookieToList(newCookie)) {
+      // It is purpose that created us; purpose that connects us;
+      // purpose that pulls us; that guides us; that drives us.
+      // It is purpose that defines us; purpose that binds us.
+      // When a cookie no longer has purpose, it has a choice:
+      // it can return to the source to be deleted, or it can go
+      // into exile, and stay hidden inside the Matrix.
+      // Let's choose deletion.
+      delete newCookie;
+    }
+  }
+
+  mCookieChanged = PR_FALSE;
+  return NS_OK;
+}
+
+PR_STATIC_CALLBACK(PLDHashOperator)
+cookieListCallback(nsCookieEntry *aEntry,
+                   void          *aArg)
+{
+  for (nsCookie *cookie = aEntry->Head(); cookie; cookie = cookie->Next()) {
+    NS_STATIC_CAST(nsVoidArray*, aArg)->AppendElement(cookie);
+  }
+  return PL_DHASH_NEXT;
+}
+
+nsresult
+nsCookieContainer::Write()
+{
+  if (!mCookieChanged) {
+    return NS_OK;
+  }
+
+  if (!mCookieFile) {
+    return NS_ERROR_NULL_POINTER;
+  }
+
+  nsresult rv;
+  nsCOMPtr<nsIOutputStream> fileOutputStream;
+  rv = NS_NewSafeLocalFileOutputStream(getter_AddRefs(fileOutputStream),
+                                       mCookieFile,
+                                       -1,
+                                       0600);
+  if (NS_FAILED(rv)) {
+    NS_ERROR("failed to open cookies.txt for writing");
+    return rv;
+  }
+
+  // get a buffered output stream 4096 bytes big, to optimize writes
+  nsCOMPtr<nsIOutputStream> bufferedOutputStream;
+  rv = NS_NewBufferedOutputStream(getter_AddRefs(bufferedOutputStream), fileOutputStream, 4096);
+  if (NS_FAILED(rv)) {
+    return rv;
+  }
+
+  static const char kHeader[] =
+      "# HTTP Cookie File\n"
+      "# http://wp.netscape.com/newsref/std/cookie_spec.html\n"
+      "# This is a generated file!  Do not edit.\n"
+      "# To delete cookies, use the Cookie Manager.\n\n";
+  // note: kTrue and kFalse have leading/trailing tabs already added
+  static const char kTrue[] = "\tTRUE\t";
+  static const char kFalse[] = "\tFALSE\t";
+  static const char kTab[] = "\t";
+  static const char kNew[] = "\n";
+
+  // create a new nsVoidArray to hold the cookie list, and sort it
+  // such that least-recently-used cookies come last
+  nsVoidArray sortedCookieList(mCookieCount);
+  mHostTable.EnumerateEntries(cookieListCallback, &sortedCookieList);
+  sortedCookieList.Sort(compareCookiesForWriting, nsnull);
+
+  bufferedOutputStream->Write(kHeader, sizeof(kHeader) - 1, &rv);
+
+  /* file format is:
+   *
+   * host \t isDomain \t path \t secure \t expires \t name \t cookie
+   *
+   * isDomain is "TRUE" or "FALSE"
+   * isSecure is "TRUE" or "FALSE"
+   * expires is a PRInt64 integer
+   * note 1: cookie can contain tabs.
+   * note 2: cookies are written in order of lastAccessed time:
+   *         most-recently used come first; least-recently-used come last.
+   */
+
+  /*
+   * XXX but see above in ::Read for the HttpOnly hack
+   */
+   
+  nsCookie *cookie;
+  nsInt64 currentTime = NOW_IN_SECONDS;
+  char dateString[22];
+  PRUint32 dateLen;
+  for (PRUint32 i = 0; i < mCookieCount; ++i) {
+    cookie = NS_STATIC_CAST(nsCookie*, sortedCookieList.ElementAt(i));
+
+    // don't write entry if cookie has expired, or is a session cookie
+    if (cookie->IsSession() || cookie->Expiry() <= currentTime) {
+      continue;
+    }
+
+    // XXX hack for HttpOnly. see bug 178993.
+    if (cookie->IsHttpOnly()) {
+      bufferedOutputStream->Write(kHttpOnlyPrefix, sizeof(kHttpOnlyPrefix) - 1, &rv);
+    }
+    bufferedOutputStream->Write(cookie->Host().get(), cookie->Host().Length(), &rv);
+    if (cookie->IsDomain()) {
+      bufferedOutputStream->Write(kTrue, sizeof(kTrue) - 1, &rv);
+    } else {
+      bufferedOutputStream->Write(kFalse, sizeof(kFalse) - 1, &rv);
+    }
+    bufferedOutputStream->Write(cookie->Path().get(), cookie->Path().Length(), &rv);
+    if (cookie->IsSecure()) {
+      bufferedOutputStream->Write(kTrue, sizeof(kTrue) - 1, &rv);
+    } else {
+      bufferedOutputStream->Write(kFalse, sizeof(kFalse) - 1, &rv);
+    }
+    dateLen = PR_snprintf(dateString, sizeof(dateString), "%lld", PRInt64(cookie->Expiry()));
+    bufferedOutputStream->Write(dateString, dateLen, &rv);
+    bufferedOutputStream->Write(kTab, sizeof(kTab) - 1, &rv);
+    bufferedOutputStream->Write(cookie->Name().get(), cookie->Name().Length(), &rv);
+    bufferedOutputStream->Write(kTab, sizeof(kTab) - 1, &rv);
+    bufferedOutputStream->Write(cookie->Value().get(), cookie->Value().Length(), &rv);
+    bufferedOutputStream->Write(kNew, sizeof(kNew) - 1, &rv);
+  }
+
+  // All went ok. Maybe except for problems in Write(), but the stream detects
+  // that for us
+  nsCOMPtr<nsISafeOutputStream> safeStream = do_QueryInterface(bufferedOutputStream);
+  NS_ASSERTION(safeStream, "expected a safe output stream!");
+  if (safeStream) {
+    rv = safeStream->Finish();
+    if (NS_FAILED(rv)) {
+      NS_WARNING("failed to save cookie file! possible dataloss");
+      return rv;
+    }
+  }
+
+  mCookieChanged = PR_FALSE;
+  return NS_OK;
+}
+
+// this is a backend function for adding a cookie to the list, via SetCookie.
+// also used in the cookie manager, for profile migration from IE.
+// it either replaces an existing cookie; or adds the cookie to the hashtable,
+// and deletes a cookie (if maximum number of cookies has been
+// reached). also performs list maintenance by removing expired cookies.
+void
+nsCookieContainer::AddInternal(nsCookie  *aCookie,
+                               nsInt64    aCurrentTime,
+                               nsIURI     *aHostURI,
+                               const char *aCookieHeader)
+{
+  nsListIter matchIter;
+  const PRBool foundCookie =
+    FindCookie(aCookie->Host(), aCookie->Name(), aCookie->Path(), matchIter);
+
+  nsRefPtr<nsCookie> oldCookie;
+  if (foundCookie) {
+    oldCookie = matchIter.current;
+    RemoveCookieFromList(matchIter);
+
+    // check if the cookie has expired
+    if (aCookie->Expiry() <= aCurrentTime) {
+      COOKIE_LOGFAILURE(SET_COOKIE, aHostURI, aCookieHeader, "previously stored cookie was deleted");
+      NotifyChanged(oldCookie, NS_LITERAL_STRING("deleted").get());
+      return;
+    }
+
+    // preserve creation time of cookie
+    if (oldCookie) {
+      aCookie->SetCreationTime(oldCookie->CreationTime());
+    }
+
+  } else {
+    // check if cookie has already expired
+    if (aCookie->Expiry() <= aCurrentTime) {
+      COOKIE_LOGFAILURE(SET_COOKIE, aHostURI, aCookieHeader, "cookie has already expired");
+      return;
+    }
+
+    // check if we have to delete an old cookie.
+    nsEnumerationData data(aCurrentTime, LL_MAXINT);
+    if (CountCookiesFromHostInternal(aCookie->RawHost(), data) >= mMaxCookiesPerHost) {
+      // remove the oldest cookie from host
+      oldCookie = data.iter.current;
+      RemoveCookieFromList(data.iter);
+
+    } else if (mCookieCount >= mMaxNumberOfCookies) {
+      // try to make room, by removing expired cookies
+      RemoveExpiredCookies(aCurrentTime);
+
+      // check if we still have to get rid of something
+      if (mCookieCount >= mMaxNumberOfCookies) {
+        // find the position of the oldest cookie, and remove it
+        data.oldestTime = LL_MAXINT;
+        FindOldestCookie(data);
+        oldCookie = data.iter.current;
+        RemoveCookieFromList(data.iter);
+      }
+    }
+
+    // if we deleted an old cookie, notify consumers
+    if (oldCookie)
+      NotifyChanged(oldCookie, NS_LITERAL_STRING("deleted").get());
+  }
+
+  // add the cookie to head of list
+  AddCookieToList(aCookie);
+  NotifyChanged(aCookie, foundCookie ? NS_LITERAL_STRING("changed").get()
+                                     : NS_LITERAL_STRING("added").get());
+
+  COOKIE_LOGSUCCESS(SET_COOKIE, aHostURI, aCookieHeader, aCookie);
+}
+
+/******************************************************************************
+ * nsCookieService impl:
+ * private cookielist management functions
+ ******************************************************************************/
+
+void
+nsCookieContainer::RemoveAllFromMemory()
+{
+  // clearing the hashtable will call each nsCookieEntry's dtor,
+  // which releases all their respective children.
+  mHostTable.Clear();
+  mCookieCount = 0;
+  mCookieChanged = PR_TRUE;
+}
+
+PLDHashOperator PR_CALLBACK
+removeExpiredCallback(nsCookieEntry *aEntry,
+                      void          *aArg)
+{
+  nsCookieContainer* container = NS_REINTERPRET_CAST(nsCookieContainer*, ((void**)aArg)[0]);
+  const nsInt64 &currentTime = *NS_STATIC_CAST(nsInt64*, ((void**)aArg)[1]);
+  for (nsListIter iter(aEntry, nsnull, aEntry->Head()); iter.current; ) {
+    if (iter.current->Expiry() <= currentTime)
+      // remove from list. this takes care of updating the iterator for us
+      container->RemoveCookieFromList(iter);
+    else
+      ++iter;
+  }
+  return PL_DHASH_NEXT;
+}
+
+// removes any expired cookies from memory
+void
+nsCookieContainer::RemoveExpiredCookies(nsInt64 aCurrentTime)
+{
+  void* args[2];
+  args[0] = this;
+  args[1] = &aCurrentTime;
+  mHostTable.EnumerateEntries(removeExpiredCallback, &args);
+}
+
+// find whether a given cookie has been previously set. this is provided by the
+// nsICookieManager2 interface.
+NS_IMETHODIMP
+nsCookieContainer::CookieExists(nsICookie2 *aCookie,
+                                PRBool     *aFoundCookie)
+{
+  NS_ENSURE_ARG_POINTER(aCookie);
+
+  // just a placeholder
+  nsEnumerationData data(NOW_IN_SECONDS, LL_MININT);
+  nsCookie *cookie = NS_STATIC_CAST(nsCookie*, aCookie);
+
+  *aFoundCookie = FindCookie(cookie->Host(), cookie->Name(), cookie->Path(), data.iter);
+  return NS_OK;
+}
+
+// count the number of cookies from a given host, and simultaneously find the
+// oldest cookie from the host.
+PRUint32
+nsCookieContainer::CountCookiesFromHostInternal(const nsACString  &aHost,
+                                              nsEnumerationData &aData)
+{
+  PRUint32 countFromHost = 0;
+
+  nsCAutoString hostWithDot(NS_LITERAL_CSTRING(".") + aHost);
+
+  const char *currentDot = hostWithDot.get();
+  const char *nextDot = currentDot + 1;
+  do {
+    nsCookieEntry *entry = mHostTable.GetEntry(currentDot);
+    for (nsListIter iter(entry); iter.current; ++iter) {
+      // only count non-expired cookies
+      if (iter.current->Expiry() > aData.currentTime) {
+        ++countFromHost;
+
+        // check if we've found the oldest cookie so far
+        if (aData.oldestTime > iter.current->LastAccessed()) {
+          aData.oldestTime = iter.current->LastAccessed();
+          aData.iter = iter;
+        }
+      }
+    }
+
+    currentDot = nextDot;
+    if (currentDot)
+      nextDot = strchr(currentDot + 1, '.');
+
+  } while (currentDot);
+
+  return countFromHost;
+}
+
+// count the number of cookies stored by a particular host. this is provided by the
+// nsICookieManager2 interface.
+NS_IMETHODIMP
+nsCookieContainer::CountCookiesFromHost(const nsACString &aHost,
+                                      PRUint32         *aCountFromHost)
+{
+  // we don't care about finding the oldest cookie here, so disable the search
+  nsEnumerationData data(NOW_IN_SECONDS, LL_MININT);
+  
+  *aCountFromHost = CountCookiesFromHostInternal(aHost, data);
+  return NS_OK;
+}
+
+// find an exact previous match.
+PRBool
+nsCookieContainer::FindCookie(const nsAFlatCString &aHost,
+                            const nsAFlatCString &aName,
+                            const nsAFlatCString &aPath,
+                            nsListIter           &aIter)
+{
+  nsCookieEntry *entry = mHostTable.GetEntry(aHost.get());
+  for (aIter = nsListIter(entry); aIter.current; ++aIter) {
+    if (aPath.Equals(aIter.current->Path()) &&
+        aName.Equals(aIter.current->Name())) {
+      return PR_TRUE;
+    }
+  }
+
+  return PR_FALSE;
+}
+
+// removes a cookie from the hashtable, and update the iterator state.
+void
+nsCookieContainer::RemoveCookieFromList(nsListIter &aIter)
+{
+  if (!aIter.prev && !aIter.current->Next()) {
+    // we're removing the last element in the list - so just remove the entry
+    // from the hash. note that the entryclass' dtor will take care of
+    // releasing this last element for us!
+    mHostTable.RawRemoveEntry(aIter.entry);
+    aIter.current = nsnull;
+
+  } else {
+    // just remove the element from the list, and increment the iterator
+    nsCookie *next = aIter.current->Next();
+    NS_RELEASE(aIter.current);
+    if (aIter.prev) {
+      // element to remove is not the head
+      aIter.current = aIter.prev->Next() = next;
+    } else {
+      // element to remove is the head
+      aIter.current = aIter.entry->Head() = next;
+    }
+  }
+
+  --mCookieCount;
+  mCookieChanged = PR_TRUE;
+}
+
+PRBool
+nsCookieContainer::AddCookieToList(nsCookie *aCookie)
+{
+  nsCookieEntry *entry = mHostTable.PutEntry(aCookie->Host().get());
+
+  if (!entry) {
+    NS_ERROR("can't insert element into a null entry!");
+    return PR_FALSE;
+  }
+
+  NS_ADDREF(aCookie);
+
+  aCookie->Next() = entry->Head();
+  entry->Head() = aCookie;
+  ++mCookieCount;
+  mCookieChanged = PR_TRUE;
+
+  return PR_TRUE;
+}
+
+PR_STATIC_CALLBACK(PLDHashOperator)
+findOldestCallback(nsCookieEntry *aEntry,
+                   void          *aArg)
+{
+  nsEnumerationData *data = NS_STATIC_CAST(nsEnumerationData*, aArg);
+  for (nsListIter iter(aEntry, nsnull, aEntry->Head()); iter.current; ++iter) {
+    // check if we've found the oldest cookie so far
+    if (data->oldestTime > iter.current->LastAccessed()) {
+      data->oldestTime = iter.current->LastAccessed();
+      data->iter = iter;
+    }
+  }
+  return PL_DHASH_NEXT;
+}
+
+void
+nsCookieContainer::FindOldestCookie(nsEnumerationData &aData)
+{
+  mHostTable.EnumerateEntries(findOldestCallback, &aData);
+}
